
#define    WINEXPORT WINAPI 

#define	HERC_OK					0	// all is OK
#define HERC_ERROR_INIT			1	// Hercules DJ Console is not initialized
#define HERC_ERROR_PORT			2	// can't open midi port
#define HERC_ERROR_THREAD		3	// can't start midi event thread
#define HERC_ERROR_DEVICE		4	// can't find a valid Hercules DJ Console

//RIGHT / LEFT
#define HERC_MODE				1000
#define HERC_PLAY				1001
#define HERC_CUE				1002
#define HERC_AUTOBEAT			1003
#define HERC_TRACKPREV			1004
#define HERC_TRACKNEXT			1005
#define HERC_THREE				1006
#define HERC_TWO				1007
#define HERC_ONE				1008
#define HERC_PITCHBEND_UP		1009
#define HERC_PITCHBEND_DOWN		1010
#define HERC_PREVIEW			1011
#define HERC_MASTERTEMPO		1012
#define HERC_MOUSEBUTTON		1013
#define HERC_BASS				1014
#define HERC_MEDIUM				1015
#define HERC_TREBLE				1016
#define HERC_PITCH				1017
#define HERC_VOLUME				1018
#define HERC_JOGWHEEL			1019
#define HERC_SELECTFX			1023
	
//BOTH
#define HERC_CROSSFADER			1020
#define HERC_JOYSTICK_HOR		1021
#define HERC_JOYSTICK_VER		1022

//LED CODES
#define HERC_LED_PLAY			2000
#define HERC_LED_CUE			2001
#define HERC_LED_AUTOBEAT		2002
#define HERC_LED_MONITOR		2003
#define HERC_LED_MASTERTEMPO	2004
#define HERC_LED_LOOPFX			2005
#define HERC_LED_CUEFX			2006
#define HERC_LED_FX				2007
#define HERC_LED_FLASHPLAY		2008
#define HERC_LED_FLASHCUE		2009


//Console Types
#define HERC_CONSOLE			3000 //try to initialize regular herc console
#define HERC_CONSOLE_MK2		3001 //try to initialize mk2 herc console
#define HERC_CONSOLE_MP3		3002 //try to initialize control mp3 console
#define HERC_CONSOLE_ALL		3004 //initialize first hercules console it finds

const int LeftPlay =					0x80000000;
const int LeftCue  =					0x00010000;
const int LeftTrackPrev =				0x00040000;
const int LeftTrackNext =				0x00080000;
const int LeftPitchBendPlus =			0x00000400;
const int LeftPitchBendMinus =			0x00000800;
const int LeftPreview =	     			0x00001000;
const int LeftOne =						0x00400000;
const int LeftTwo =						0x00200000;
const int LeftThree =					0x00100000;
const int LeftSelectFX =				0x40000000;
const int LeftMasterTempo =				0x00002000;
const int LeftAutoBeat =				0x00020000;
const int LeftMouseButton =				0x00000004;


const int RightPlay =					0x02000000;
const int RightCue  =					0x04000000;
const int RightTrackPrev =				0x10000000;
const int RightTrackNext =				0x20000000;
const int RightPitchBendPlus =			0x00004000;
const int RightPitchBendMinus =			0x00008000;
const int RightPreview =	     		0x00000001;
const int RightOne =					0x00800000;
const int RightTwo =					0x00000100;
const int RightThree =					0x00000200;
const int RightSelectFX =				0x01000000;
const int RightMasterTempo =			0x00000002;
const int RightAutoBeat =				0x08000000;
const int RightMouseButton =			0x00000008;


HWND			hidwnd = NULL;	
HWND			mainhwnd = NULL;
static HANDLE	Vis_hThread=0;									
HANDLE			theThread=0;			 
DWORD			dwVis_hThreadId=0;	
UINT			Vis_Enable_Rendering = 0;
int		id=-1;		
DWORD			m_dwConsoleType = 0;

HANDLE	Vis_New_Thread_Init();
DWORD	WINAPI HID_New_Thread(LPVOID);
LRESULT CALLBACK WndProc(HWND , UINT , WPARAM , LPARAM);
HWND	Create_HID_Window(void);
void	Destroy_HID_Window(void);


typedef void (CALLBACK HERCPROC)(DWORD dwAction, DWORD dwValue, DWORD user);
DWORD HERC_ErrorCode=HERC_OK;
BOOL  bInitialized = FALSE;
BOOL  bCallbackSet = FALSE;


DWORD    WINEXPORT HERC_GetVersion();
BOOL	 WINEXPORT HERC_Init(DWORD dwConsoleType=HERC_CONSOLE_ALL, HWND hwnd=NULL);
BOOL	 WINEXPORT HERC_EventCallbackSet(HERCPROC*,HERCPROC*, DWORD);
BOOL     WINEXPORT HERC_Free();
DWORD    WINEXPORT HERC_ErrorGetCode();
BOOL	 WINEXPORT HERC_SetLED(DWORD dwDeckID, DWORD dwLEDCode, BOOL bOn);

void CALLBACK ReadHercTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);

UINT hercread = 0;

UINT WorkerThread(LPVOID pParam);
BOOL bTerminated = FALSE;

DWORD	  m_dwUser=0;
HERCPROC* m_proca=0;
HERCPROC* m_procb=0;

BOOL	m_bModeDownDeckA=FALSE;
BOOL	m_bPlayDownDeckA=FALSE;
BOOL	m_bCueDownDeckA=FALSE;
BOOL	m_bTrackPrevDownDeckA = FALSE;
BOOL	m_bTrackNextDownDeckA = FALSE;
BOOL	m_bAutoBeatDownDeckA = FALSE;
BOOL	m_bOneDownDeckA = FALSE;
BOOL	m_bTwoDownDeckA = FALSE;
BOOL	m_bThreeDownDeckA = FALSE;
BOOL	m_bPitchBendUpDownDeckA = FALSE;
BOOL	m_bPitchBendDownDownDeckA = FALSE;
BOOL	m_bPreviewDownDeckA = FALSE;
BOOL	m_bMasterTempoDownDeckA = FALSE;
BOOL	m_bSelectFXDownDeckA = FALSE;
BOOL	m_bMouseButtonDownDeckA = FALSE;

BOOL	m_bModeDownDeckB=FALSE;
BOOL	m_bPlayDownDeckB=FALSE;
BOOL	m_bCueDownDeckB=FALSE;
BOOL	m_bTrackPrevDownDeckB = FALSE;
BOOL	m_bTrackNextDownDeckB = FALSE;
BOOL	m_bAutoBeatDownDeckB = FALSE;
BOOL	m_bOneDownDeckB = FALSE;
BOOL	m_bTwoDownDeckB = FALSE;
BOOL	m_bThreeDownDeckB = FALSE;
BOOL	m_bPitchBendUpDownDeckB = FALSE;
BOOL	m_bPitchBendDownDownDeckB = FALSE;
BOOL	m_bPreviewDownDeckB = FALSE;
BOOL	m_bMasterTempoDownDeckB = FALSE;
BOOL	m_bSelectFXDownDeckB = FALSE;
BOOL	m_bMouseButtonDownDeckB = FALSE;

int		m_nLastBass[2] = {-1,-1};
int		m_nLastMid[2] = {-1,-1};
int		m_nLastTreble[2] = {-1,-1};
int		m_nLastVolume[2] = {-1,-1};
int		m_nLastPitch[2] = {-1,-1};
int		m_nLastJogWheel[2] = {-1,-1};

int m_nLastFade = -1;



