#define    WINEXPORT WINAPI 

#define	HERC_OK				0	// all is OK
#define HERC_ERROR_INIT		1	// Hercules DJ Console is not initialized
#define HERC_ERROR_PORT		2	// can't open midi port
#define HERC_ERROR_THREAD	3	// can't start midi event thread
#define HERC_ERROR_DEVICE	4	// can't find a valid Hercules DJ Console

//RIGHT / LEFT
#define HERC_MODE				1000
#define HERC_PLAY				1001
#define HERC_CUE				1002
#define HERC_AUTOBEAT			1003
#define HERC_TRACKPREV			1004
#define HERC_TRACKNEXT			1005
#define HERC_THREE				1006
#define HERC_TWO				1007
#define HERC_ONE				1008
#define HERC_PITCHBEND_UP		1009
#define HERC_PITCHBEND_DOWN		1010
#define HERC_PREVIEW			1011
#define HERC_MASTERTEMPO		1012
#define HERC_MOUSEBUTTON		1013
#define HERC_BASS				1014
#define HERC_MEDIUM				1015
#define HERC_TREBLE				1016
#define HERC_PITCH				1017
#define HERC_VOLUME				1018
#define HERC_JOGWHEEL			1019
#define HERC_SELECTFX			1023
	
//BOTH
#define HERC_CROSSFADER			1020
#define HERC_JOYSTICK_HOR		1021
#define HERC_JOYSTICK_VER		1022

//LED
#define HERC_LED_PLAY				2000
#define HERC_LED_CUE				2001
#define HERC_LED_AUTOBEAT			2002
#define HERC_LED_MONITOR			2003
#define HERC_LED_MASTERTEMPO			2004
#define HERC_LED_LOOPFX				2005
#define HERC_LED_CUEFX				2006
#define HERC_LED_FX				2007
#define HERC_LED_FLASHPLAY		2008
#define HERC_LED_FLASHCUE		2009


//Console Types
#define HERC_CONSOLE			3000 //try to initialize regular herc console
#define HERC_CONSOLE_MK2		3001 //try to initialize mk2 herc console
#define HERC_CONSOLE_MP3		3002 //try to initialize control mp3 console
#define HERC_CONSOLE_ALL		3004 //initialize first hercules console it finds


typedef void (CALLBACK HERCPROC)(DWORD dwAction, DWORD dwValue, DWORD user);

DWORD    WINEXPORT HERC_GetVersion();
BOOL	 WINEXPORT HERC_Init(DWORD dwConsoleType=HERC_CONSOLE_ALL, HWND hwnd=NULL);
BOOL	 WINEXPORT HERC_EventCallbackSet(HERCPROC*,HERCPROC*, DWORD);
BOOL     WINEXPORT HERC_Free();
DWORD    WINEXPORT HERC_ErrorGetCode();
BOOL	 WINEXPORT HERC_SetLED(DWORD dwDeckID, DWORD dwLEDCode, BOOL bOn);


